package silmar.contexts.gameplay.entities.terrains.specializations

import silmarengine.contexts.gameplay.entities.beings.player.Player
import silmarengine.contexts.gameplay.entities.beings.player.extensions.messages.onMessage
import silmarengine.contexts.gameplay.entities.terrains.Terrain1
import silmar.contexts.gameplay.areas.extensions.effects.Moat
import silmar.contexts.gameplay.areas.extensions.effects.performMoatCreationEffect
import silmar.contexts.gameplay.areas.extensions.effects.performMoatRemovalEffect
import silmarengine.contexts.gameplay.areas.geometry.TileDistance

class MoatLever : Terrain1() {

    /**
     * Whether this moat=lever is currently in the "on" position.
     */
    private var turnedOn = false

    /**
     * The list of tile-locations currently occupied by the moat generated by this lever.
     */
    private var moat: Moat? = null

    override fun onInteractionWithPlayer(player: Player): Boolean {
        // if this lever is in the "off" position
        if (!turnedOn) {
            turnedOn = true

            player.onMessage("Working this lever causes a moat to appear!")

            // form the moat
            moat = area.performMoatCreationEffect(location, TileDistance(2))
        }
        else {
            turnedOn = false

            // remove the moat
            area.performMoatRemovalEffect(moat!!)
        }

        return true
    }
}